import { ConfigCollector } from './config-collector';
interface Options {
    preferedParseMethod: boolean;
}
export declare class ConfigCollection {
    protected preferedParseMethod: boolean;
    files: ConfigCollector[];
    constructor(opts?: Options);
    /**
     * The directory will be read and then control
     *  will be passed to this.handleFiles
     * @param path Path to directory
     */
    handleDirectory(path?: string, extfilter?: string): this;
    /**
     * Take several files into the collection
     * @param files Path to files
     */
    handleFiles(files: string[], root?: string, extfilter?: string): this;
    /**
     * Fetch files in directory. Doesn't save files to the instance.
     * Instead of config.handleDirectory('./config').files.forEach(file =>
     *  console.log(file.fullPath);
     * );
     * @param dirname
     */
    fetch(dirname: string, cb: (file: ConfigCollector) => void): void;
    getFiles(): string[];
    /**
     * Find file and maybe take something from that.
     * @param name File name
     * @param selector JsonQuery.Selector
     */
    find(name: string, selector?: string): any;
}
export {};
