import { ConfigParser } from "./config-parser";
export declare class ConfigCollector {
    name?: string;
    extension?: string;
    private _path?;
    protected parser?: ConfigParser;
    protected preferedParseMethod: boolean;
    /**
     * The default parser is the ConfigParser plain
     * @param path Path to configuration file
     * @param preferedParseMethod Sync | Async (undone)
     */
    constructor(path: string, preferedParseMethod?: boolean);
    protected path: string;
    readonly fullName: string;
    getPath(): string;
    readonly fullPath: string;
    /**
     * Test the parser"s parsable extension and
     *  if fine set the parser as default
     * @param parser Parser for the config file
     */
    setParser(parser: ConfigParser): boolean;
    /**
     * Call method parse of the parser
     */
    parse(method?: boolean): {};
    /**
     * Queries are strings that describe an object or value to
     * pluck out, or manipulate from the context object. The
     * syntax is a little bit CSS, a little bit JS, but pretty powerful
     * @example https://www.npmjs.com/package/json-query
     * @param selector
     * @param parsed The main object to query | default this.parse()
     */
    query(selector: string, parsed?: object): any;
    QueryJson(selector: string, data: object): any;
}
