interface SchemeDbTypeOptions {
    unique?: boolean;
    primaryKey?: boolean;
    autoIncrement?: boolean;
    unsigned?: boolean;
    foreign?: {
        table: string;
        field: string;
    };
}
export declare class Field {
    protected name: string;
    protected dtype: string;
    protected props: SchemeDbTypeOptions;
    constructor(name: string, datatype: string, props?: SchemeDbTypeOptions);
    getAll(): {
        name: string;
        type: string;
        props: SchemeDbTypeOptions;
    };
}
export declare class Scheme {
    protected $fields: Field[];
    constructor(fields: Field[]);
    number(name: string, props?: SchemeDbTypeOptions): void;
    autoIncrements(name?: string): void;
    string(name: string, props?: SchemeDbTypeOptions): void;
    json(name: string): void;
    boolean(name: string, props?: SchemeDbTypeOptions): void;
    test(msg: any): void;
    foreign(name: string): {
        references(tableName: string): {
            on(field: string): void;
        };
    };
    timestamps(): void;
}
export {};
