export declare class DBType {
    protected canBeUnique: boolean;
    protected canBePrimaryKey: boolean;
    protected canBeHashed: boolean;
    protected _is_unique: boolean;
    protected _is_primarykey: boolean;
    protected _is_hashed: boolean;
    protected _frozen: boolean;
    protected _value: any;
    value: any;
    isFrozen: boolean;
    isUnique: boolean;
    isPrimaryKey: boolean;
    isHashed: boolean;
    constructor(value: any);
    /**
     * If possible create hash for the value,
     *  original value will be lost. And freeze the
     *  statement
     */
    complete(): void;
    /**
     * Get original value
     */
    decode(): any;
}
export declare class Number extends DBType {
    protected postFix(val: number): number;
    value: any;
}
export declare class Integer extends Number {
    protected postFix(val: number): number;
}
export declare class Binary extends Integer {
    protected postFix(val: number): number;
}
export declare class Boolean extends DBType {
    value: boolean | number;
}
/**
 * Length=[0, 255]
 */
export declare class String extends DBType {
    protected _value: string;
    protected _range: number;
    value: any;
}
export declare class Text extends String {
    protected _range: number;
}
